VCMD0028040100000000COMPONENT          
Node "rSimResource"
{
Name "ButtonControlledLifter"
Id 1
NodeClass 
{
Id 1
Feature "rPrimitiveBoxFeature"
{
Name "Block"

Matrix 1 0 0 0 0 1 0 0 0 0 1 0 -50 -50 0 1 
Visible 1
Length 
{
  Expression "100 {mm}"
}

Width 
{
  Expression "100 {mm}"
}

Height 
{
  Expression "10"
}

}
VCID "204486a0-83be-419a-878f-e6bb0d7a88b2"
}
Functionality "rPythonScript"
{
Id 1
Name "PythonScript"
Script "from vcScript import *\ncomp = getComponent()
\nbtnNames = [\"MoveUp\", \"MoveDown\",\"StopMovement\"]
\nservo = comp.getBehaviour(\"Servo Controller\")
\n
\ndef OnButtonPress( arg ):
\n  global target
\n  suspendRun()
\n  if arg.Name == btnNames[0]:
\n    target = comp.UpperLimit
\n  elif arg.Name == btnNames[1]:
\n    target = comp.LowerLimit
\n  else:
\n    target = servo.getJoint(0).CurrentValue
\n  resumeRun()
\n\ndef OnRun():
\n  global target
\n  target = servo.getJoint(0).CurrentValue
\n  while True:
\n    condition(lambda: round(servo.getJoint(0).CurrentValue,2) != round(target,2))
\n    servo.move(target)
\n  
\nbtn1 = comp.getProperty(btnNames[0])\nif not btn1:
\n  btn1 = comp.createProperty(VC_BUTTON, btnNames[0])
\nbtn1.OnChanged = OnButtonPress
\nbtn2 = comp.getProperty(btnNames[1])
\nif not btn2:
\n  btn2 = comp.createProperty(VC_BUTTON, btnNames[1])
\nbtn2.OnChanged = OnButtonPress
\nbtn3 = comp.getProperty(btnNames[2])
\nif not btn3:
\n  btn3 = comp.createProperty(VC_BUTTON, btnNames[2])
\nbtn3.OnChanged = OnButtonPress
\n
\n"
CompatibilityMode 0
}
Functionality "rSimKinController"
{
Id 2
Name "Servo Controller"
Joints
{
  JointInfo
  {
    Index 0
    DofObject "J1"
  }
}
DummyDofs
{
}
UseHeartbeat 0
HeartRate 0
UsePhysicalHeartbeat 0
RootNode "ButtonControlledLifter"
FlangeNode "Link_1"
}
VCID 204486a0-83be-419a-878f-e6bb0d7a88b2
Revision 7
Location 1 0 0 0 0 1 0 0 0 0 1 0 0 0 0 1 
ActiveSimulationLevel detailed
BOMname  "NewComponent"

BOMdescription  ""

Category  ""

VariableSpace ""
{
  Variable "rTVariable<rBool>"
  {
    Name "Visible"
    Value 1
    Group -1130
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      MANAGED
    }
  }
  Variable "rTVariable<rButton>"
  {
    Name "StopMovement"
    Value 1
    Group 81
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
    }
  }
  Variable "rTVariable<rDouble>"
  {
    Name "UpperLimit"
    Value 1000
    Group 40
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      ON_EDIT_REBUILD
      TRANSLATE_USING_GETTEXT
    }
  }
  Variable "rTVariable<rDouble>"
  {
    Name "LowerLimit"
    Value 0
    Group 50
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      ON_EDIT_REBUILD
      TRANSLATE_USING_GETTEXT
    }
  }
  Variable "rTVariable<rButton>"
  {
    Name "MoveUp"
    Value 1
    Group 70
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
    }
  }
  Variable "rTVariable<rButton>"
  {
    Name "MoveDown"
    Value 1
    Group 80
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
    }
  }
}
Node "rSimLink"
{
Name "Link_1"
Id 2
NodeClass 
{
Id 2
Feature "rPrimitiveCylinderFeature"
{
Name "Cylinder"

Visible 1
Radius 
{
  Expression "50 {mm}"
}

Height 
{
  Expression "100 {mm}"
}

StartSweep 
{
  Expression "0 {deg}"
}

EndSweep 
{
  Expression "360 {deg}"
}

Sections 
{
  Expression "12"
}

Caps 1
}
}
Dof  "Translational"
{
  Name "J1"
  Properties
  {
    Variable "rTExpressionVariable<rDouble>"
    {
      Name "SoftMinLimit"
      Value
      {
        Expression ""
      }
      Group 33
      Settings
      {
        VISIBLE
        EDITABLE_DISCONNECTED
        EDITABLE_CONNECTED
        EDITABLE_SIMULATING
      }
    }
    Variable "rTExpressionVariable<rDouble>"
    {
      Name "SoftMaxLimit"
      Value
      {
        Expression ""
      }
      Group 34
      Settings
      {
        VISIBLE
        EDITABLE_DISCONNECTED
        EDITABLE_CONNECTED
        EDITABLE_SIMULATING
      }
    }
    Variable "rTVariable<rDouble>"
    {
      Name "MaxSpeed"
      Value 100
      Group 35
      Settings
      {
        VISIBLE
        EDITABLE_DISCONNECTED
        EDITABLE_CONNECTED
        EDITABLE_SIMULATING
        TRANSLATE_USING_GETTEXT
      }
      Quantity "Speed" "ScalarQuantity"
      {
        Groups
        {
          UnitGroup "US Speed"
          {
            Unit
            {
              Name "feet per minute"
              Suffix "fpm"
              Factor 5.07999992370605
              Offset 0
            }
            Family "US degrees"
            Family "a"
          }
          UnitGroup "mm/min"
          {
            Unit
            {
              Name "dfdf"
              Suffix "m/min"
              Factor 1
              Offset 0
            }
          }
        }
      }
      Magnitude 1
    }
    Variable "rTVariable<rDouble>"
    {
      Name "MaxAcceleration"
      Value 500
      Group 36
      Settings
      {
        VISIBLE
        EDITABLE_DISCONNECTED
        EDITABLE_CONNECTED
        EDITABLE_SIMULATING
        TRANSLATE_USING_GETTEXT
      }
      Quantity "Acceleration"
      Magnitude 1
    }
    Variable "rTVariable<rDouble>"
    {
      Name "MaxDeceleration"
      Value 500
      Group 37
      Settings
      {
        VISIBLE
        EDITABLE_DISCONNECTED
        EDITABLE_CONNECTED
        EDITABLE_SIMULATING
        TRANSLATE_USING_GETTEXT
      }
      Quantity "Acceleration"
      Magnitude 1
    }
    Variable "rTVariable<rDouble>"
    {
      Name "LagTime"
      Value 0
      Group 41
      Settings
      {
        VISIBLE
        EDITABLE_DISCONNECTED
        EDITABLE_CONNECTED
        EDITABLE_SIMULATING
        TRANSLATE_USING_GETTEXT
      }
      Quantity "Time"
      Magnitude 1
    }
    Variable "rTVariable<rDouble>"
    {
      Name "SettleTime"
      Value 0
      Group 42
      Settings
      {
        VISIBLE
        EDITABLE_DISCONNECTED
        EDITABLE_CONNECTED
        EDITABLE_SIMULATING
        TRANSLATE_USING_GETTEXT
      }
      Quantity "Time"
      Magnitude 1
    }
  }
  JointValue 0
  MinLimit
  {
    Expression ""
  }
  MaxLimit
  {
    Expression ""
  }
  AxisType 2
  JointDeflection
  {
    Expression "VALUE"
  }
}
Offset 
{
  Expression ""
}
}
}
